<?
/*
Stronghold CMS Configuration File

If you're maintaining multiple systems, you may find it easier to place your
organisation specific configuration options in a single file (eg. database
connection variables), and include the file in this configuration file.
*/

$CONFIG["system_state"]=1; //0 = offline, 1 = online, 2 = comming soon, 3 = offline for maintenance
$CONFIG["system_allow"]=NULL; //array of permitted host ip addresses
$CONFIG["system_name"]="Stronghold CMS";
$CONFIG["system_contact"]="The Administrator";
$CONFIG["system_email"]="root@localhost";
$CONFIG["system_session"]="stronghold_";
$CONFIG["system_domain"]="www.mydomain.com"; //the DNS name of the host
$CONFIG["system_tech"]="the IT Deparment"; //a string used to refer users, eg. 'encounterd [description] error, please contact [system_tech].'
$CONFIG["system_path"]="/opt/stronghold/www.mydomain.com"; // the installation folder
$CONFIG["system_datastore"]=$CONFIG["system_path"]."/_datastore"; //the location of the data store for binaries
$CONFIG["system_nav_default"]="list"; //auto navigation (list), set to NULL to disable

// Database
$CONFIG["db_type"]="postgres"; //database type - postgres, mssql, mysql, oracle
$CONFIG["db_server"]="localhost";
$CONFIG["db_database"]="CMS";
$CONFIG["db_username"]="postgres";
$CONFIG["db_password"]="password";
$CONFIG["db_table_prefix"]="stronghold_";
$CONFIG["db_common_prefix"]="common_"; //shared resources

// Security
$CONFIG["security_auth"]="ntlm"; //ntlm, adldap, or database
$CONFIG["security_domain"]="MYDOMAIN"; //the domain if you use Active Directory integration
$CONFIG["security_ssl"]=1; //force the browser to use SSL
$CONFIG["security_pass"]=NULL; //login as any user with this password, set to NULL to disable

// adLDAP options
$CONFIG["adldap_account_suffix"]="@mydomain.local";
$CONFIG["adldap_base_dn"]="DC=mydomain,DC=local";
$CONFIG["adldap_domain_controllers"]=array("dc01.mydomain.local");
$CONFIG["adldap_ad_username"]="";
$CONFIG["adldap_ad_password"]="";

// Email Error Reporting
// We'd really appreciate it if you allow us to stay in the loop with error reports,
// it helps us with quality control. You can disable this by setting it to an empty array
$CONFIG["error_reporting"]=array($CONFIG["system_email"],"errors@strongholdcms.org"); // You can specify an array of email addresses
?>