<?
/*
Stronghold CMS - Confirmation
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

$mode=prepare_str($_GET["mode"]);
if ($mode==NULL){ header ("Location: menu.php"); exit(); }


//******************************************************************************************************

if ($mode=="new_version"){

	$version_id=prepare_int($_GET["version_id"]);
	
	if ($version_id){
		$msg="Creating a new version will copy the content from the old version into the new version.";
		$yes=prepare_str(urldecode($_GET["url"])."?mode=edit&version_id=".$version_id."&newversion=1");
		$no=prepare_str(urldecode($_GET["url"]));
		
		$document=array();
		$document["title"]="Create New Version";
		$document["body"]=yes_no($msg,$yes,$no);;
		include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
		exit();
	}
}


if ($mode=="cancel_version"){
	$version_id=prepare_int($_GET["version_id"]);
	
	if ($version_id){
		$msg="Canceling a version removes the necessity to have it approved, but does not remove the page.";
		$yes=prepare_str(urldecode($_GET["url"])."?mode=edit&version_id=".$version_id."&cancel=1");
		$no=prepare_str(urldecode($_GET["url"]));

		$document=array();
		$document["title"]="Cancel Version";
		$document["body"]=yes_no($msg,$yes,$no);
		include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
		exit();
	}
}

if ($mode=="archive_resource"){
	$resource_id=prepare_int($_GET["resource_id"]);
	
	if ($resource_id){
		$msg="Archiving a resource will remove it from the website.";
		$yes="/stronghold/resources/file.php?archive=1&resource_id=".$resource_id;
		$no="/stronghold/resources/menu.php?resource_id=".$resource_id;

		$document=array();
		$document["title"]="Archive Resource";
		$document["body"]=yes_no($msg,$yes,$no);
		include ($_SERVER["DOCUMENT_ROOT"]."/includes/skinny_template.php");
		exit();
	}
}





function yes_no($message,$yes_location,$no_location){
	$b.="<p>".$message."</p>";
	$b.="<div align='center'><p><strong>Are you sure?</strong><br>This action cannot be undone.</p>";
	$b.="<table border='0' width='400'><tr><td align='center'>\n";
	$b.=button_href("Yes",$yes_location,"approve.gif");
	$b.="</td><td align='center'>";
	$b.=button_href("No",$no_location,"archive.gif");
	$b.="</td></tr></table></div>\n";
	return ($b);
}

?>
