<?
/*
Stronghold CMS - Group Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/extended.php");

$group_id=request_key("group_id");

if (prepare_int($_POST["oldform"])){
	$group_id=prepare_str($_POST["group_id"]);
	$group_name=prepare_str($_POST["group_name"]);

	$errors=array();
	if ($group_name==NULL){ $errors["group_name"]="<span class='errormessage'>Please enter a group name</span><br>\n"; }

	if ($group_id=="new"){ $group_id=group_create($db,$CONFIG["db_table_prefix"],$group_name); }
	else { group_modify($db,$CONFIG["db_table_prefix"],$group_id,$group_name); }
}

//-------------------------------------------------------------------------------

if ($group_id && $group_id!="new"){
	$g=retrieve_group($db,$CONFIG["db_table_prefix"],$group_id);
	if (!$g){ fatal ("Could not load specified group"); }
	$group_name=$g["title"];
}

$b.="<p>This interfaces exists to add groups and modify group names only.
Removing a group can cause problems in your database and fatal errors on the website.</p>";

//jump menu
$groups=retrieve_groups($db,$CONFIG["db_table_prefix"]);
$b.=generic_jump($groups,prepare_str($_SERVER["PHP_SELF"])."?group_id=",$group_id);

if ($group_id){
	//load the group
		
	$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='group_maintenance'>\n";
	$b.="<input type='hidden' value='1' name='oldform'>\n";
	$b.="<input type='hidden' value='".$group_id."' name='group_id'>\n";
	$b.="<table border='0' class='dtable'>\n";
	$b.="<tr>\n";
	$b.="<th>Group:</th>\n";
	$b.="<td><input type='text' name='group_name' value='".$group_name."'>".$error["group_name"]."</td>\n";
	$b.="</tr>\n";
	$b.="<tr><td colspan='2' align='center'><br>".button_submit("group_maintenance","update","Update","save.gif")."</td></tr>\n";
	$b.="</table>\n";
	$b.="</form>";
} else {
	$b.="<p>Please select a group.</p>";
}
$b.=button_href("Return to Menu","membership.php","return.gif");

$document=array();
$document["title"]="Group Membership";
$document["body"]=$b;
$javascript=array();
$javascript["jump_menu"]=1;

include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
