<?
/*
Stronghold CMS - Permissions Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/


$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

$group_id=NULL;

$page_id=prepare_int($_GET["page_id"]);
if ($page_id==NULL){ $page_id=prepare_int($_POST["page_id"]); }
if ($page_id==NULL){ fatal ("Permissions Manager Fault: No page_id specified"); }

$oldform=prepare_int($_POST["oldform"]);
if ($oldform){ //have a submitted form
	//print_r($_POST); exit();

	$group_id=prepare_int($_POST["group_id"]);
	$access_id=prepare_int($_POST["access_id"]);

	
	$del=array_search("Delete",$_POST); //we need a false return, can't use prepare_ till a bit lower
	if ($del!==false){
		$bits=explode("_",prepare_str($del));
		if (count($bits)!=2){ fatal("Permissions Manager Fault: Invalid deletion key"); }
		$del_group_id=prepare_int($bits[1]);
		if (!del_group_id){ fatal("Permissions Manager Fault: Invalid deletion group"); }
		
		//delete an old entry
		$sql="DELETE FROM ".$CONFIG["db_table_prefix"]."acl WHERE group_id=".$del_group_id." AND page_id=".$page_id;
		//echo ($sql);
		$db->query($sql);		
	} else {
		//create a new entry
	
		$error=array();
		if ($group_id==NULL){ $error["group_id"]="<span class='errormessage'>Please select a group</span>"; }
		if ($access_id==NULL){ $error["access_id"]="<span class='errormessage'>Please select an access level</span>"; }
		
		if (count($error)==0){
			$sql="INSERT INTO ".$CONFIG["db_table_prefix"]."acl (group_id,page_id,access) VALUES (".$group_id.",".$page_id.",".$access_id.")";
			$db->query($sql);
			//echo ($sql);
		}
	}
	
} else {
	//first form load, set default values
}

//----------------------------------------------------------------------------------------------------------------------

//load the page
$sql="SELECT page_id,parent,workflow_id,link,module_id FROM ".$CONFIG["db_table_prefix"]."pages WHERE page_id=".$page_id;
$rs=$db->query($sql);
if (count($rs)!=1){ fatal("Permissions Manager Fault: Could not locate page"); }
$r=$rs[0];

//load all the data objects
$permissions=retrieve_permissions($db,$CONFIG["db_table_prefix"],$page_id);
$groups=retrieve_groups($db,$CONFIG["db_table_prefix"]);
$levels=retrieve_useraccess($db,$CONFIG["db_common_prefix"]);
//pre($permissions);

//------------------------------------------------------------------------

//$b="<p>greyed out.</p>";

$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='stronghold_permissions'>\n";
$b.="<input type='hidden' name='page_id' value='".$page_id."'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";

$b.=button_href("Return to Menu","menu.php","return.gif");
$b.=$error["access_id"].$error["group_id"];
$b.="<br><br><table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Granted On</th>\n";
$b.="<th>Group</th>\n";
$b.="<th>Level</th>\n";
$b.="<th>Delete</th>\n";
$b.="</tr>\n";
foreach ($permissions as $current_page_id => $values){
	if ($current_page_id!=$page_id){ $bgcolor=" bgcolor='#dddddd'"; } else { $bgcolor=NULL; } //highlight inherited permissions
	
	foreach ($values["permissions"] as $id => $p){
		$b.="<tr".$bgcolor.">\n";
		$b.="<td><a href='".prepare_str($_SERVER["PHP_SELF"])."?page_id=".$current_page_id."'>".$values["url"]."</a></td>";			
		$b.="<td>".$groups[$p["group_id"]]."</td>\n";
		$b.="<td>".$levels[$p["access"]]."</td>\n";
		if ($current_page_id==$page_id){ $remove=button_submit("stronghold_permissions","remove_".$p["group_id"],"Delete","archive.gif"); } else { $remove=NULL; }
		$b.="<td>".$remove."</td>\n";
		$b.="</tr>\n";	
	}
}
$b.="</table>\n";
$b.="<br><br>\n";



$b.="<table border='1' class='dtable'>\n";
$b.="<tr><th>Add Permission</th></tr>\n";
$b.="<tr>\n";
$b.="<td>".
	generic_select("group_id",$groups,$group_id)." ".
	generic_select("access_id",$levels,$access_id,true,false)." ".
	button_submit("stronghold_permissions","permissions","Create","permissions.gif").
"</td>\n";
$b.="</tr>\n";
$b.="</table>\n";

$b.="</form>";

$b.=button_href("Return to Menu","menu.php","return.gif");

$document=array();
$document["title"]="Permissions Manager";
$document["body"]=$b;

include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
