<?
/*
Stronghold CMS - Resource Tree Menu, Dtree implementation
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

----------------------------------------------------------------
Dtree is a really good tree script, but it won't handle thousands
of nodes (or more to the point, javascript in client web browsers
won't). If you have an exceedingly large tree structure, you will
have to use an RPC implementation to keep the number of nodes and
amount of data down.

http://www.destroydrop.com/javascripts/tree/
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");

$node_id=prepare_int($_GET["node_id"]);

$tree_data=retrieve_resource_tree($db,$CONFIG["db_table_prefix"]);
//pre($tree_data);

echo ("<html>");
echo ("<head>\n");
echo ("<link rel=\"StyleSheet\" href=\"/includes/dtree/dtree.css\" type=\"text/css\" />\n");
echo ("<script type=\"text/javascript\" src=\"/includes/dtree/dtree.js\"></script>\n");
echo ("</head>");

echo ("<body>");

echo (dtree($tree_data["tree"],$tree_data["resources"],"menu.php",$node_id));


echo ("</body>");
echo ("</html>");

//-----------------------------------------------------------------------------------------------------

// display a dtree given the tree and the resources
function dtree($tree,$resources,$target,$node_select){
	$id=1;

	$html="<div class='dtree'>\n";
	//<p><a href="javascript: d.openAll();">open all</a> | <a href="javascript: d.closeAll();">close all</a></p>
	$html.="<script type=\"text/javascript\">\n<!--\n";
	$html.="d = new dTree('d');\n";
	$html.=display_dtree($tree,$resources,$target,$id); //$id must be a variable, it's passed by reference
	$html.="document.write(d);\n";
	if ($node_select){ $html.="d.openTo(".$resources[$node_select]["id_map"].",true);\n"; } //if there's a node selected, call the javascript select
	$html.="//-->\n</script>\n";
	$html.="</div><br>\n";
	
	return ($html);
}

// display a dtree leaf (recursive)
function display_dtree($tree,&$resources,$target,&$id){
	
	foreach ($tree as $node_id => $children){
		$resources[$node_id]["id_map"]=$id; //store the mapped id
		$node=$resources[$node_id]; //load the node

		if ($node["parent"]=="0"){
			$parent="-1";
			//$folder=1;
		} else {
			$parent=$resources[ $node["parent"] ]["id_map"];
			//if ($node_id[0]=="n"){ $folder=1; } else { $folder=0; }
		}
		//if ($folder){ $img="folder.gif"; } else { $img="page.gif"; }
		$buffer.="d.add(".$id.",".$parent.",'".$node["title"]."','".$target."?node_id=".$node_id."','','menu','/includes/dtree/img/folder.gif');\n";

		$id++;
		$buffer.=display_dtree($children,$resources,$target,$id);
	}
	return ($buffer);
}
?>
