<?
/*
Stronghold CMS - Resource Tree
Copyright (C) 2008 Scott Barnett

The Stronghold Resource Tree is built from components in the Yahoo YUI Library
http://developer.yahoo.com/yui/

The Stronghold Team would like to acknowledge Yahoo's leetness for providing
such ultra cool sc00by snacks to the developer community.

In the spirit of sharing and respecting their licencing choice, this script ONLY
is free to use under the same licence as selected by Yahoo (the BSD Licence).

-------------------------------------------------------------------------
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer
  in the documentation and/or other materials provided with the distribution. 
- Neither the name of the Scott Barnett nor the names of its contributors may be used to endorse or promote products derived
  from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-------------------------------------------------------------------------
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head>


<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><!--Yahoo! User Interface Library: http://twiki.corp.yahoo.com/view/Devel/PresentationPlatform--><!--Begin YUI CSS infrastructure, including Standard Reset, Standard Fonts, and CSS Page Grids -->

<link rel="stylesheet" type="text/css" href="/includes/yui/fonts/fonts.css">
<link rel="stylesheet" type="text/css" href="/includes/yui/grids/grids.css">

<script src="/includes/yui/yahoo/yahoo-min.js"></script>
<script src="/includes/yui/event/event-min.js"></script>
<script src="/includes/yui/connection/connection-min.js"></script>  
<script src="/includes/yui/treeview/treeview-min.js"></script>

<link rel="stylesheet" type="text/css" href="/includes/yui/css/code.css">
<link rel="stylesheet" type="text/css" href="/includes/yui/css/local/tree.css">

<script>



/*create namespace for examples:*/
YAHOO.namespace("example");

/* Using Crockford's "Module Pattern": */
YAHOO.example.treeExample = function() {
	var tree, currentIconMode;

	function changeIconMode() {
		var newVal = parseInt(this.value);
		if (newVal != currentIconMode) { currentIconMode = newVal; }
		buildTree();
	}
	
		function loadNodeData(node, fnLoadComplete) {

			//var examine=node['data'];
			//for(var p in examine){ if (p=="eartag"){ alert(p+"---"+node[p]); } }
			var eartag = node['data']['eartag'];
			var div = document.getElementById('container');

			var handleSuccess = function(o){
				var node=o.argument;
				var response = eval('(' + o.responseText + ')'); //decode the json
				for(var p in response){ 
					objnode=response[p];
//					for(var p in objnode){ if (p=="eartag"){ alert(p+"---"+objnode[p]); } }
					var newNode = new YAHOO.widget.TextNode({ label: objnode["title"], href:"/stronghold/resources/menu.php?node="+objnode['node'], target:"menu" }, node, false);
					newNode.eartag=objnode['node'];
				}
				fnLoadComplete();
			}

			var handleFailure = function(o){
				document.getElementById('debug_text').innerHTML='<p>Load failed</p>';
				fnLoadComplete();
			}
			var callback = { success:handleSuccess, failure: handleFailure, argument: node };
			var request = YAHOO.util.Connect.asyncRequest('GET', "/stronghold/resources/tree_rpc.php?node="+node['eartag'], callback); 
		}

	function buildTree() {
		tree = new YAHOO.widget.TreeView("treeContainer");
		tree.setDynamicLoad(loadNodeData, currentIconMode); //turn dynamic loading on for entire tree:
		
		var root = tree.getRoot(); //get root node for tree:
		
		//add child nodes for tree:
<?
$resource=new resource($db,$CONFIG["db_table_prefix"]);
$menu=$resource->child_nodes(1);
foreach ($menu["folders"] as $folder_node_id => $folder){
	echo ("var tmpNode1 = new YAHOO.widget.TextNode({ label:\"".$folder["node_name"]."\",  href:\"/stronghold/resources/menu.php?node=n".$folder_node_id."\", target:\"menu\" }, root, false);\n");
	echo ("tmpNode1.eartag=\"n".$folder_node_id."\";\n");
}
/*

//			server_response = document.getElementById('response');
//			for(var p in server_response){ if (p=="value"){ alert(p+"---"+server_response[p]); }}
			//for(var p in server_response){ alert(p+"---"+server_response[p]); }
			//json_string=server_response['value'];
	//		alert("2 - "+server_response['value']);
eartag:\"n".$folder_node_id."\",
//			for(var p in node){ alert(p+"---"+node[p]); }
		var tmpNode1 = new YAHOO.widget.TextNode({ label:"First Node", eartag:"n"}, root, false);
		var tmpNode2 = new YAHOO.widget.TextNode("Second Node", root, false);
		var tmpNode3 = new YAHOO.widget.TextNode("Third Node", root, false);
		var tmpNode4 = new YAHOO.widget.TextNode("Fourth Node", root, false);
		var tmpNode5 = new YAHOO.widget.TextNode("Fifth Node", root, false);
*/
?>
		tree.draw();
	}


	return {
		init: function() {
			YAHOO.util.Event.on(["mode0", "mode1"], "click", changeIconMode);
			var el = document.getElementById("mode1");
			if (el && el.checked) {
				currentIconMode = parseInt(el.value);
			} else {
				currentIconMode = 0;
			}

            buildTree();
        }

	}
} ();

YAHOO.util.Event.addListener(window, "load", YAHOO.example.treeExample.init, YAHOO.example.treeExample,true)
</script>
<title>Dynamic TreeView Example</title>
</head>

<body id="yahoo">
<div id="debug_text"></div>
<div id="treeContainer" align='left'></div>	
<div id="container"></div>
</body>
</html>
