<?
/*
Stronghold CMS - Sitemap Module
Copyright (C) 2008  Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*/

$status_codes=array(1=>"New",2=>"Pending",3=>"Approved",4=>"Cancelled");

/*
load_module($db,$page)
view_module($db,$page,$module)
new_module($db,$page,$module)
edit_module($db,$page,$module,$errors=NULL)
post_module($db,$page,$module)
approve_module($db,$page,$version)
cancel_module()
*/

function load_module($db,$page){
	//module information
	$sql="SELECT * FROM ".$GLOBALS["CONFIG"]["db_table_prefix"]."module_sitemap WHERE page_id=".$page["page_id"];
	$rs=$db->query($sql);
	if (count($rs)!=1){ $b.="FATAL: Could not load content for sitemap".$page["page_id"]); exit(); }
	
	//create the module object
	$module=$rs[0];
	$module["navigation"]=retrieve_flat_nav($db,$GLOBALS["CONFIG"]["db_table_prefix"],$page["page_id"]);

	return ($module);
}


function view_module($db,$page,$module){
	$temp=retrieve_recursive_nav($db,1,NULL);
	$map=$temp["map"];
	$pages=$temp["pages"];

	function sitemap_child($arr,$nav_pages,$level){
		$level=$level+1;
		foreach ($arr as $key => $children){
			$child=$nav_pages[$key];
			for ($i=0; $i<($level-1); $i++){ $b.="-- "); }
			$b.="<a href='".$child["url"]."'>".decode($child["short_title"])."</a><br>\n";
			sitemap_child($children,$nav_pages,$level);
		}
	}

	if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]){ $b.="<table border='0'><tr><td width='90%'>\n"; }

	sitemap_child($map,$pages,0);

	if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]){
		$b.="</td><td>\n";
		box_approvals($db,$page,$module["modified"]);
		$b.="</td></tr></table>";
	}
	
	$document=array();
	$document["body"]=;
	$document["title"]=decode($module["title"]);
	if ($module["heading"]){ $document["heading"]=$document["title"]; }
	
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
}


function cancel_module($db,$page,$module){

}

// Duplicate an existing module
function new_module($db,$page,$module){

}

function edit_module($db,$page,$module,$errors=NULL){

}

function post_module($db,$page,$module){

}

function approve_module($db,$page,$version){

}


function box_approvals($db,$page,$modified){
	$status_codes=array(1=>"New",2=>"Pending",3=>"Approved",4=>"Cancelled"); //hack
	$groups=retrieve_groups($db,$GLOBALS["CONFIG"]["db_table_prefix"]);
	//pre($page);

	$b.="<table border='1' class='dtable'>\n";
	$b.="<tr><th>Page Info</th></tr>\n";
	$b.="<tr><td>\n";
		$b.="<table border='0'>\n";
		$b.="<tr><td>Page Key:</td>\n";
		$b.="<td>".$page["page_id"].".".$page["version"]."</td></tr>\n";
		$b.="<tr><td>Approvals:</td>\n";
		$b.="<td>");

		foreach ($page["workflows"] AS $key=>$group_id){
			if (in_array($group_id,$page["approvals"])){
				 $b.="<font color='#009900'>".$groups[$group_id]."</font><br>\n";
			} else {
				 $b.="<font color='#ff0000'>".$groups[$group_id]."</font><br>\n";
			}
		}
		
		$b.="</td></tr>\n";
		$b.="<tr><td>Modified:</td><td>".date("H:i d/m/Y",$modified)."</td></tr>\n";
		$b.="<tr><td>Versions:</td><td>";
		if (prepare_str($_GET["mode"])=="edit"){ $edit="&mode=edit"; } else { $edit=NULL; }
		foreach ($page["versions"] as $version_id => $status){
			$b.="<a href='".prepare_str($_SERVER["PHP_SELF"])."?version=".$version_id.$edit."'>".$version_id." - ".$status_codes[$status]."</a><br>";
		}
		$b.="</td></tr>\n";
		$b.="<tr><td colspan='2'><img src='/resources/images/pixel.gif' height='1' width='200'></td></tr>";
		$b.="</table>";			
	$b.="</td></tr></table><br>\n";
	return ($b);
}



?>
