<?
/*
Stronghold CMS - Session Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

session_start();

//pre($_SERVER);
if ($_SERVER["HTTPS"]=="on"){ $protocol="https"; } else { $protocol="http"; } //used by header redirects

if ($requires_access!=NULL){
	if (is_array($_SESSION[$CONFIG["system_session"]."access"])){ //if they're already logged in

		$has_access=false;
		foreach ($_SESSION[$CONFIG["system_session"]."access"] as $group_id => $access){
			if ($access>=$requires_access){ $has_access=true; }
		}
		if (!$has_access){ echo ("FATAL: You do not have access to this area."); exit(); }
		
	} else {
	
		$b="<p>Due to a long period of inactivity, your session has expired.</p>";
		$b.="<input type='button' class='mb' value='Log In Again' onclick='window.location=\"/stronghold/login.php\"'><br>\n";
		$document["title"]="Expired Session";
		$document["body"]=$b;
		include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
		exit();
	}
}
?>
