<?
/*
Stronghold CMS - NTLM authentication portal
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/
include ("../config.php");

//bomb out if they're trying to use SSL
if ($_SERVER["SERVER_PORT"]==443){ echo ("FATAL: Cannot use NTLM authentication over SSL."); exit(); }

session_start();

//bomb out if we've already tried NTLM
//if (isset($_SESSION["ntlm_result"])){ echo ("FATAL: I've already tried NTLM authentication. Breaking out to prevent a browser loop."); exit(); }

$result="no";

if ($_SERVER["REMOTE_USER"]!=NULL){
	$bits=explode("+",$_SERVER["REMOTE_USER"]);
	if (count($bits)==2 && $bits[0]==$CONFIG["security_domain"]){
		$_SESSION["ntlm_username"]=$bits[1];
		$result="yes";
	}
}

$_SESSION["ntlm_result"]=$result;

if (isset($CONFIG["cms_systems"])){ //if we're in a labyrinth
	$location="https://".$_SERVER["HTTP_HOST"]."/index.php";
} else {
	$location="https://".$_SERVER["HTTP_HOST"]."/stronghold/login.php";
}
header ("Location: ".$location); exit();
?>
