<?
/*
Stronghold CMS - Resources Tree RPC
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");

//logging/debugging
$syslog="";

//figure out what we're dealing with
$node=prepare_str($_GET["node"]);
$node_type=prepare_str($node[0]);
$node_id=prepare_int($node); //will strip the text
$syslog.="node_id: ".$node_id." type:".$node_type." ";

//load the node
$resource=new resource($db,$CONFIG["db_table_prefix"]);
$menu=$resource->child_nodes($node_id);

//pre($menu); exit();

if (is_array($menu)){
	//send the nodes with JSON
	$json=array();
	foreach ($menu["folders"] as $folder_id => $folder){
		//$json[]="{title:\"".$folder["node_name"]."\",isFolder:true,objectId:\"n".$folder_id."\"}";
		$node=array("title"=>$folder["node_name"],"node"=>"n".$folder_id);
		$json[]=$node;
		$syslog.="(".implode(",",$node).")";
	}
	echo (json_encode($json));
} else {
	$syslog.=" 404!!!";
}

//log the transaction
system ("echo \"".addslashes($syslog)."\"  >> /tmp/rpc.log");

/*
$nodes=array();
$nodes[]=array(
	"title"=>"first node",
	"node_id"=>"r13"
);
$nodes[]=array(
	"title"=>"second node node",
	"node_id"=>"n55"
);
*/

//echo ("<br>[{title:\"odoyle rules\",isFolder:true,objectId:\"myobj\"},{title:\"scott rules\"}]");
//[{title:"work",isFolder=>true,objectId=>"n4"},{title:"demo",isFolder=>true,objectId=>"n5"}]
///{title:"work","node_id"=>"n4"},{"title":"baby","node_id"=>"n22"}]
?>
