<?
/*
Stronghold CMS - User Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
//include ($_SERVER["DOCUMENT_ROOT"]."/_system/extended.php");

$aduser=false;

$showdisabled=prepare_int($_GET["showdisabled"]);
if ($showdisabled==NULL){ $showdisabled=prepare_int($_POST["showdisabled"]); }
if ($showdisabled==NULL){ $showdisabled=0; }

$orderby=prepare_str($_GET["orderby"]);
if ($orderby==NULL){ $orderby="username"; }

//*********************************************************************************************************************************

$access=retrieve_useraccess($db,$CONFIG["db_common_prefix"]);
$users=retrieve_users($db,$CONFIG["db_common_prefix"],$orderby);
//pre($users);

$b.="<p>All user information is replicated from Active Directory.<br>Once a user is added to the system, their account can be disabled but it cannot be deleted.</p>\n";
if ($user_error){ $b.="<span class='errormessage'>ERROR: ".$user_error."</span>\n"; }

$b.="<form method='post' action='user.php' name='user_maintenance'>\n";
$b.="<table border='1' class='dtable' cellspacing='0' cellpadding='4'>\n";
$b.="<tr><th>Add Account (Username Search)</th></tr>\n";
$b.="<tr><td><input type='text' name='adsearch' value=''> ".button_submit("user_maintenance","search","Search","search.gif")."</td></tr>\n";
$b.="</table><br>\n";

if (is_dir($_SERVER["DOCUMENT_ROOT"]."/labyrinth")){ $b.=button_href("Return to Menu","/labyrinth/menu.php","return.gif"); } //labyrinth menu
else { $b.=button_href("Return to Menu","menu.php","return.gif"); } //return to the stronghold menu
$b.=button_href("Add User","user.php","user_create.gif");
$b.="</form>\n";
//$b.="<br>\n";

$b.="<table border='0' class='dtable'>\n";

$b.="<tr>\n";
$b.="<th>ID</th>\n";
$b.="<th><a href='".prepare_str($_SERVER["PHP_SELF"])."?orderby=username'>Usename</a></th>\n";
$b.="<th><a href='".prepare_str($_SERVER["PHP_SELF"])."?orderby=firstname'>First Name</a></th>\n";
$b.="<th><a href='".prepare_str($_SERVER["PHP_SELF"])."?orderby=surname'>Surname</a></th>\n";
$b.="<th><a href='".prepare_str($_SERVER["PHP_SELF"])."?orderby=email'>Email</a></th>\n";
$b.="<th><a href='".prepare_str($_SERVER["PHP_SELF"])."?orderby=access'>Access</a></th>\n";
$b.="<th>Options</th>\n";
$b.="</tr>\n";

foreach ($users as $user_id => $user){
	$b.="<tr>\n";
	$b.="<td>".$user_id."</td>\n";
	$b.="<td>".$user["username"]."</td>\n";
	$b.="<td>".$user["firstname"]."</td>\n";
	$b.="<td>".$user["surname"]."</td>\n";
	$b.="<td><a href='mailto:".$user["email"]."'>".$user["email"]."</a></td>\n";
	$b.="<td>".$access[$user["access"]]."</td>\n";
	$b.="<td>".button_href("Edit","user.php?user_id=".$user_id."","user_edit.gif")."</td>\n";
	$b.="</tr>\n";
}

$b.="</table><br>\n";

$document=array();
$document["title"]="Manage Users";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>