<?
/*
Stronghold CMS - Workflow Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

$db_table_prefix=$CONFIG["db_table_prefix"];

$oldform=prepare_int($_POST["oldform"]);
if ($oldform){ //have a submitted form

	$add_workflow_id=prepare_str($_POST["add_workflow_id"]);
	if ($add_workflow_id!="New"){ $add_workflow_id=prepare_int($add_workflow_id); }
	$add_group_id=prepare_int($_POST["add_group_id"]);
	
	if ($add_workflow_id!=NULL && $add_group_id!=NULL){
		if ($add_workflow_id=="New"){
			$sql="SELECT MAX (workflow_id) AS max_workflow_id FROM ".$db_table_prefix."workflow";
			$rs=$db->query($sql);
			$add_workflow_id=$rs[0]["max_workflow_id"]+1;
		}
		
		//check the group isn't already in the workflow
		$sql="SELECT workflow_id FROM ".$db_table_prefix."workflow WHERE workflow_id=".$add_workflow_id." AND group_id=".$add_group_id;
		$rs=$db->query($sql);
		if (count($rs)==0){		
			//create it
			$sql="INSERT INTO ".$db_table_prefix."workflow (workflow_id,group_id) VALUES (".$add_workflow_id.",".$add_group_id.")";
			$db->query($sql);
			$already_exists=false;
		} else {
			$already_exists=true;
		}
	}
	
	foreach ($_POST as $key => $value){  //prepare_int done in the loop
		if ($value=="Remove" && substr($key,0,7)=="remove_"){
			$vals=explode("_",$key);
			$workflow_id=prepare_int($vals[1]);
			$group_id=prepare_int($vals[2]);
			
			if ($workflow_id!=NULL && $group_id!=NULL){
				$sql="DELETE FROM ".$db_table_prefix."workflow WHERE workflow_id=".$workflow_id." AND group_id=".$group_id;
				//echo $sql;
				$db->query($sql);
			}
		}
	}
}


//************************************************************************************************

// load the data objects
$workflows=retrieve_workflows($db,$db_table_prefix);
$groups=retrieve_groups($db,$db_table_prefix);

$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='workflow_maintenance'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";

$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>ID</th>\n";
$b.="<th>Groups</th>\n";
$b.="</tr>\n";
foreach ($workflows AS $workflow_id => $workflow_groups){
	$b.="<tr>\n";
	$b.="<td>".$workflow_id."</td>\n";
	$b.="<td>";
		$b.="<table border='0' class='dtable' width='100%' cellspacing='0' cellpadding='2'>\n";
		foreach ($workflow_groups as $id => $group_id){ 
			$b.="<tr>\n";
			$b.="<td width='90%'>".$groups[$group_id]."</td>\n";
			$b.="<td width='10%'>".button_submit("workflow_maintenance","remove_".$workflow_id."_".$group_id,"Remove","archive.gif")."</td>\n";
			$b.="</tr>\n";
		}
		$b.="</table>\n";
	$b.="</td>\n";
	$b.="</tr>\n";
}
$b.="</table>\n";
$b.="<br>";

$select_workflows=array();
$select_workflows[0]="New";
$select_workflows=array_merge($select_workflows,array_keys($workflows));

$b.="<table border='0' class='dtable'>\n";
$b.="<tr><th>Add Group</th></tr>\n";
$b.="<tr>\n";
$b.="<td>";
$b.="Add ".generic_select("add_group_id",$groups,NULL);
$b.=" to Workflow ".generic_select("add_workflow_id",$select_workflows,NULL,false);
$b.=button_submit("workflow_maintenance","add","Add","groups.gif");
$b.="</td>\n";
$b.="</tr>\n";
$b.="</table>\n";
if ($already_exists){ $b.="<br><span class='errormessage'>The group already exists in the workflow you're trying to add it to!</span>\n"; }

$b.="<br><br>".button_href("Return to Menu","menu.php","return.gif");
$b.="</form>";

$document=array();
$document["title"]="Workflows";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
